<?php
// ++=========================================================================++
// || CinVin vB Forum Feed Listing v1.0.2 - 1
// ||  2006 CinVin - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://www.CinVin.com
// || Downloaded 14:58, Thu Dec 7th 2006
// || 
// ++ ========================================================================++


// ####################### SET PHP ENVIRONMENT ########################### 
error_reporting(E_ALL & ~E_NOTICE); 

// #################### DEFINE IMPORTANT CONSTANTS ####################### 
define('NO_REGISTER_GLOBALS', 1); 
define('THIS_SCRIPT', 'CV_RSS_FEEDS'); // change this depending on your filename 

// define('VBA_PORTAL', true);
// define('VBA_PAGE', 'cv_rss_feeds');

// ########################## DEBUG MODE? ################################
$debug_mode = 0;
if ($debug_mode) {
   print 'DEBUG MODE IS TURNED ON!<br />';
}

// ################### PRE-CACHE TEMPLATES AND DATA ###################### 
// get special phrase groups 
  $phrasegroups = array(
    'forum'
);

// get special data templates from the datastore 
  $specialtemplates = array(     
); 

// pre-cache templates used by all actions 
$globaltemplates = array( 
  'cv_ffl_forumlist',
  'cv_ffl_forum_bit_forum_name',
  'cv_ffl_forum_bit_noposts',
  'cv_ffl_forum_bit_posts',
  'cv_ffl_forum_category_seperator',
  'cv_ffl_forum_feed_link',
  'cv_ffl_forum_link',
  'cv_ffl_forum_sub_forum_indicator'
); 

// pre-cache templates used by specific actions 
  $actiontemplates = array( 
); 

// ######################### REQUIRE BACK-END ############################ 
require_once('./global.php'); 

// ####################################################################### 
// ######################## START MAIN SCRIPT ############################ 
// ####################################################################### 

$forum_url = $vbulletin->options['bburl'];    // The URL to your vBulletin forums

function construct_forum_list($parentid = -1, &$ret, $permission = '', $depth = 0, $debug_mode = 0)
{
   global $vbulletin;
   global $stylevar, $vbphrase, $defaultselected;
   global $forum_url;

   $parent_count = 0;

   if (!($vbulletin->userinfo['permissions']['forumpermissions'] & $vbulletin->bf_ugp_forumpermissions['canview']))
   {
      if ($debug_mode) {
         print 'CONDITION 1: User does not have permissions to view the forums';
      }
      return;
   }

   if (empty($vbulletin->iforumcache))
   {
      require_once('./includes/functions_forumlist.php');
      cache_ordered_forums(1, 1);
   }

   if (empty($vbulletin->iforumcache["$parentid"]) OR !is_array($vbulletin->iforumcache["$parentid"]))
   {
      return;
   }

   foreach($vbulletin->iforumcache["$parentid"] AS $forumid)
   {
      $forumperms = $vbulletin->userinfo['forumpermissions']["$forumid"];  

      $forum = $vbulletin->forumcache["$forumid"];
      $forum_title = $forum[title_clean];
      $forum_desc = strip_tags($forum['description']);

      if ((!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND !$vbulletin->options['showprivateforums']) OR !$vbulletin->forumcache["$forumid"]['displayorder'] OR !($vbulletin->forumcache["$forumid"]['options'] & $vbulletin->bf_misc_forumoptions['active']) OR ($vbulletin->forumcache["$forumid"]['link']))
      {
         if ($debug_mode) {

            print 'SKIPPING FORUM ' . $forumid . ' - ' . $forum_title . ': ';

            if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND !$vbulletin->options['showprivateforums']) {
               print 'User does not have permissions to view the forums<br />';  
            }

            if (!$vbulletin->forumcache["$forumid"]['displayorder']) {
               print 'Forum does not have a display order assigned to it<br />';  
            }

            if (!($vbulletin->forumcache["$forumid"]['options'] & $vbulletin->bf_misc_forumoptions['active'])) {
               print 'Forum is not active<br />';  
            }

            if ($vbulletin->forumcache["$forumid"]['link']) {
               print 'Forum is a link, not a real forum<br />';  
            }

         }
         continue;
      }
      else
      {
         if ($depth == 1) {
            eval('$ret.= "' . fetch_template('cv_ffl_forum_category_seperator') . '";');
         }

         if ($depth > 2) {
            for($i = 0; $i < ($depth-2); $i++) { 
               eval('$title_prefix = "' . fetch_template('cv_ffl_forum_sub_forum_indicator') . '";');
            } 
         }

         eval('$forum_link = "' . fetch_template('cv_ffl_forum_link') . '";');
         eval('$forum_feed_link = "' . fetch_template('cv_ffl_forum_feed_link') . '";');

         if ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads']) {
            eval('$ret .= "' . fetch_template('cv_ffl_forum_bit_posts') . '";');
         }
         else
         {
            eval('$ret .= "' . fetch_template('cv_ffl_forum_bit_noposts') . '";');
         }

         // If the current forum has any sub-forums, then create that list
         $depth++;
         construct_forum_list($forumid, $ret, $forumperms, $depth, $debug_mode);
         $depth--;

      } // if can view

   } // end

   return $ret;

}

// Create the 'master' RSS feed link (all forums)
$forum_desc = $vbulletin->options['description'];
$forumid = '';
eval('$forum_title = "' . fetch_template('cv_ffl_forum_bit_forum_name') . '";');
eval('$forum_link = "' . fetch_template('cv_ffl_forum_link') . '";');
eval('$forum_feed_link = "' . fetch_template('cv_ffl_forum_feed_link') . '";');
eval('$adv_portal_forumlist .= "' . fetch_template('cv_ffl_forum_bit_posts') . '";');

// Build the forum list
$adv_portal_forumlist = construct_forum_list(-1, $adv_portal_forumlist,'',1, $debug_mode);

// Build the navbar navbits
$navbits = array(); 
$navbits[$parent] = $vbphrase['cv_ffl_navbar_desc']; 
$navbits = construct_navbits($navbits); 

// Build the navbar
eval('$navbar = "' . fetch_template('navbar') . '";'); 

// Build and display the output page
eval('print_output("' . fetch_template('cv_ffl_forumlist') . '");');

?>
